stages:
  - build
  - test
  - review

.docker-build:
  image: docker:20.10.16
  stage: build
  variables:
    DOCKER_DRIVER: overlay2
    DOCKER_HOST: tcp://docker:2375
    DOCKER_TLS_CERTDIR: ""
  services:
    - docker:20.10.16-dind
  script:
    - docker login -u "$CI_REGISTRY_USER" -p "$CI_REGISTRY_PASSWORD" $CI_REGISTRY
    - |
      if [[ "$CI_COMMIT_BRANCH" == "$CI_DEFAULT_BRANCH" ]]; then
        tag=""
        echo "Running on default branch '$CI_DEFAULT_BRANCH': tag = 'latest'"
      else
        tag=":$CI_COMMIT_REF_SLUG"
        echo "Running on branch '$CI_COMMIT_BRANCH': tag = $tag"
      fi
    - docker build --pull -t "$CI_REGISTRY_IMAGE${tag}" .
    - docker push "$CI_REGISTRY_IMAGE${tag}"

.test_async:
  image: node:latest
  stage: test
  script:
    - npm install
    - npm run test

.deploy-review:
  image: node:latest
  stage: review
  script: echo "Define your deployment script!"
  environment: production

app1_build:
  stage: build
  extends: .docker-build
  before_script:
    - cd App1
  rules:
    - if: $CI_COMMIT_BRANCH
      exists:
        - App1/Dockerfile

app1_test:
  stage: test
  extends: .test_async

app1_deploy:
  stage: review
  extends: .deploy-review

app2_build:
  stage: build
  extends: .docker-build
  before_script:
    - cd App2
  rules:
    - if: $CI_COMMIT_BRANCH
      exists:
        - App2/Dockerfile

app2_test:
  stage: test
  extends: .test_async

app2_deploy:
  stage: review
  extends: .deploy-review

app3_build:
  stage: build
  extends: .docker-build
  before_script:
    - cd App3
  rules:
    - if: $CI_COMMIT_BRANCH
      exists:
        - App3/Dockerfile

app3_test:
  stage: test
  extends: .test_async

app3_deploy:
  stage: review
  extends: .deploy-review

app4_build:
  stage: build
  extends: .docker-build
  before_script:
    - cd App4
  rules:
    - if: $CI_COMMIT_BRANCH
      exists:
        - App4/Dockerfile

app4_test:
  stage: test
  extends: .test_async

app4_deploy:
  stage: review
  extends: .deploy-review